/*************************
 * Función LeerControllerPad para Tallerine Biónico
 * IIE - Facultad de Ingeniería - UDELAR
 * 2022
 * 
 * Devuelve en caso de presionar un botón en el Controller Pad el número 
 * correspondiente al botón presionado según la siguiente asignación:
 * 
 * Boton1 --> 1
 * Boton2 --> 2
 * Boton3 --> 3
 * Boton4 --> 4
 * FlechaArriba --> 5
 * FlechaAbajo --> 6
 * FlechaIzquierda --> 7
 * FlechaDerecha --> 8
 * 
 * En caso de no haber datos, timeout o error en checksum devuelve -1. 
 * Al soltar cualquier botón devuelve -2.
 * 
*/

// función para usar con packetparser.cpp
uint8_t readPacket(Stream *ble, uint16_t timeout);
extern uint8_t packetbuffer[];

#define BLE_READPACKET_TIMEOUT 1

int leerControllerPad(void)
{
   /* Espero nuevo dato */
  uint8_t len = readPacket(&(microbit.BTLESerial), BLE_READPACKET_TIMEOUT);
  if (len == 0) return -1;
  
  /* Botones*/
  if (packetbuffer[1] == 'B') {
    uint8_t botnum = packetbuffer[2] - '0'; // número correpondiente a botón
    boolean presionado = packetbuffer[3] - '0'; // evento presionar o soltar
    if (presionado) {
      return botnum; // dato botón presionado
    }else {
      return -2; // dato botón soltado
    }
  }  
}
