/*************************
 * Código prueba_ble_controller_pad para Tallerine Biónico
 * IIE - Facultad de Ingeniería - UDELAR
 * 2022
 * 
 * Prueba para la función LeerControllerPad que devuelve una conversión a int en caso del evento "presionar botón" en el Controller Pad, el número 
 * correspondiente al evento se realiza según una tabla de asignación. 
 * Si no hay datos, timeout o error en checksum devuelve -1. 
 * Al soltar cualquier botón devuelve -2.
 * 
*/

#include <Adafruit_Microbit.h>

Adafruit_Microbit microbit;

int comando = 4;
int dato = -1;

void setup() {
  // Configura velocidad de comunicación serial
  Serial.begin(9600);

  Serial.println("Inicia Controller Pad!");

  // Inicia Bluetooth (se pueden agregar servicios y características personalizados)
  microbit.BTLESerial.setLocalName("microbit");
  microbit.BTLESerial.begin();
}

void loop(void)
{
    if ((dato=leerControllerPad())>0) { // Actualizo comando en caso de una nueva lectura válida de botón presionado
      comando = dato; 
    }
    
   /*Ejecuta la función correspondiente según el comando enviado desde el control BT.*/
    switch (comando) {     
    case 1:  
      Serial.println ("Mov1");
      break;  

    case 2:  
      Serial.println ("Mov2");
      break; 
      
    case 3:  
      Serial.println ("Mov3");
      break;
           
    case 4:  
      Serial.println ("Parado");
      break;  
       
    case 5:
      Serial.println ("Avanzar");
      break;

    case 6:
      Serial.println ("Retroceder"); 
      break;

    case 7:
      Serial.println ("GiroAntiHorario");
      break;

    case 8:
      Serial.println ("GiroHorario");
      break; 
      
    default: 
      break;     
    }   
}
